
var style=document.createElement("style");
style.innerHTML+=(function() {/*
[data-asin][data-price]{
    position:relative;
}

[data-asin][data-price]:after{
    content:'最大送料' attr(data-shipping);
    background:rgba(255,0,0,.1);
    border:1px solid gray;
    position:absolute;
    top:3px;
    right:3px;
}

[data-asin][data-price][data-cashed='1']:after{
    content:'最大送料' attr(data-shipping);
    background:rgba(255,0,0,.1);
    border:1px solid gray;
    position:absolute;
    top:3px;
    right:3px;
    color:gray;
}

[data-asin][data-sagi='1']{
    background:rgba(255,0,0,.3);
    border:1px solid red;
    pointer-events2:none;
}
[data-asin][data-price][data-check_required='1']:after{
    content:'送料チェック中';
}

*/}).toString().match(/[^]*\/\*([^]*)\*\/\}$/)[1];
document.body.appendChild(style);
qd_window={};
qd_window.openHTTPs = 0;
document.body.setAttribute('openHTTPs',qd_window.openHTTPs);
function getData(elem,url){
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    qd_window.openHTTPs++;
    document.body.setAttribute('openHTTPs',qd_window.openHTTPs);
    xhr.send();
    xhr.onreadystatechange = function() {
        if(this.readyState == 4){
            qd_window.openHTTPs--;
            document.body.setAttribute('openHTTPs',qd_window.openHTTPs);
        }
        if(xhr.readyState === 4 && xhr.status === 200) {
            try{
                dom_perser(elem,xhr.responseText);
            }catch(e){
                console.warn(e);
            }
        }else if(xhr.readyState === 4 && xhr.status === 503){
            alert("アクセス規制を受けました( ´；ω；｀)");
//            setTimeout(serialShippingCheck,1000);
        }
    }
}

function unixtime(){
    var date = new Date() ;
    // UNIXタイムスタンプを取得する (ミリ秒単位)
    var a = date.getTime() ;
    // UNIXタイムスタンプを取得する (秒単位 - PHPのtime()と同じ)
    var b = Math.floor( a / 1000 ) ;
    return b;
}

function dom_perser(elem,xml){
        var parser = new DOMParser();
        var dom = parser.parseFromString(xml, 'text/html');
        var data={};
        if(localStorage["asin"+elem.dataset.asin]){
            try{
                data=JSON.parse(localStorage["asin"+elem.dataset.asin]);
            }catch(e){
                console.log(e);
            }
            data.shipping_cost_check_timestamp=unixtime();
        }else{
            data.shipping_cost_check_timestamp=unixtime();
        }
        try{
            var shipCost=0;
            var shipCostCaption="";
            var targetD=dom;
            data.shipping=shipCostCaption;
            data.shippingInt=p;
            var priceElems=targetD.querySelectorAll(".olpShippingPrice");
            for(var i=0;i<priceElems.length;i++){
                var p=parseInt(priceElems[i].innerText.replace("￥","").replace(",","").trim());
                console.log(p);
                if(p>shipCost){
                    shipCost=p;
                    shipCostCaption=priceElems[i].innerText
                    data.shipping=shipCostCaption;
                    data.shippingInt=p;
                    if( p > 500 && p > parseInt(elem.dataset.price.replace("￥","").replace(",","").replace("　","").trim())*5){
                        data.sagi=1;
                    }else{
                        data.sagi=0;
                    }
                    elem.dataset.shipping=data.shipping;
                    elem.dataset.shippingInt=data.shippingInt;
                    elem.dataset.sagi=data.sagi;
                }

            }
            localStorage["asin"+elem.dataset.asin]=JSON.stringify(data);
//            return false;
        }catch(e){
            console.log(e);
        }
        elem.dataset.check_required='0';
        serialShippingCheck();
    }    
    var startFlag=false;
    
function correctPrice(){
    var productElems=document.querySelectorAll("[data-asin]");
    for(var i=0;i<productElems.length;i++){
        console.log(productElems[i]);
        if(productElems[i].querySelector("[aria-label*='配送料']")){
            console.log(productElems[i].querySelector("[aria-label*='配送料']"))
            continue;
        }
        if(productElems[i].querySelector(".a-color-price, .a-price-whole")){
            productElems[i].dataset.check_required='1';
            productElems[i].dataset.price=productElems[i].querySelector(".a-color-price, .a-price-whole").innerText;
        };
    }
    setTimeout(serialShippingCheck,500);
}

function serialShippingCheck(){
    var productElem=document.querySelector("[data-check_required='1']");
    if(productElem){
        var elem=productElem;
        if(localStorage["asin"+elem.dataset.asin]){
            try{
                data=JSON.parse(localStorage["asin"+elem.dataset.asin]);
            }catch(e){
                console.log(e);
            }
            if(data.shipping_cost_check_timestamp){
               if(data.shipping_cost_check_timestamp + 3600 * 3 < unixtime()){
               }else{
                   console.log(elem.dataset.asin,"キャッシュを使いました");
                   elem.dataset.shipping=data.shipping;
                   elem.dataset.shippingInt=data.shippingInt;
                   elem.dataset.sagi=data.sagi;
                   elem.dataset.check_required='0';
                   elem.dataset.cashed=1;
                   serialShippingCheck();
                   return false;
               }
            }else{
            }
        }
        elem.dataset.cashed=0;
        getData(productElem,"https://www.amazon.co.jp/gp/offer-listing/"+productElem.dataset.asin+"/");

    }  
}

function soloShippingCheck(productElem){
    console.log(productElem);
    getData(productElem,"https://www.amazon.co.jp/gp/offer-listing/"+productElem.dataset.asin+"/");

}

correctPrice();
